"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.generateNotice = generateNotice;

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _bundle = require("../core/bundle");

var _constant = require("../constant/constant");

var _helpers = require("../utils/helpers");

var _i18n = _interopRequireWildcard(require("../i18n"));

var _log = _interopRequireDefault(require("../core/log"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function generateNotice(_x) {
  return _generateNotice.apply(this, arguments);
}

function _generateNotice() {
  _generateNotice = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(options) {
    var noticePath, dirname;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            try {
              noticePath = _path["default"].join(process.cwd(), _constant.NOTICE_NAME);
              (0, _helpers.runShellCmd)(function (shell) {
                return shell.rm("-rf", noticePath);
              });
              dirname = "";

              if (options.dirname) {
                dirname = _path["default"].resolve(options.dirname);
              } else {
                dirname = _path["default"].join(process.cwd(), _constant.DEP_FOLDER_NAME);
              }

              generateNoticeByDir(dirname);
            } catch (error) {
              process.exitCode = -1;

              _i18n["default"].log("notice.error", {
                error: (0, _helpers.getErrorMessage)(error)
              });

              _log["default"].debug(error);
            }

          case 1:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _generateNotice.apply(this, arguments);
}

function generateNoticeByDir(dirname) {
  if (!_fs["default"].existsSync(dirname)) {
    throw (0, _i18n.getI18nMessage)("common.noFolder", {
      folderPath: dirname
    });
  }

  var dirs = _fs["default"].readdirSync(dirname);

  var files = [];
  dirs.forEach(function (dir) {
    if (dir.startsWith("@")) {
      var subdirs = _fs["default"].readdirSync(_path["default"].join(dirname, dir)).map(function (subdir) {
        return _path["default"].join(dirname, dir, subdir);
      });

      files = files.concat(subdirs);
    } else {
      files.push(_path["default"].join(dirname, dir));
    }
  });
  var noticeFiles = [];
  files.forEach(function (f) {
    var bundleJsonPath = _path["default"].join(f, "bundle.json");

    if (_fs["default"].existsSync(bundleJsonPath)) {
      var bundle = _bundle.Bundle.from(f);

      var filePath = _path["default"].join(bundle.path, bundle.manifest.noticeFile);

      if (_fs["default"].existsSync(filePath)) {
        noticeFiles.push(filePath);
      }
    } else {
      var _filePath = _path["default"].join(f, "NOTICE");

      if (_fs["default"].existsSync(_filePath)) {
        noticeFiles.push(_filePath);
      }
    }
  });

  var targetNoticePath = _path["default"].join(process.cwd(), _constant.NOTICE_NAME);

  _bundle.Bundle.resolveNotice(noticeFiles, targetNoticePath);
}