"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.run = run;
exports.runCmd = runCmd;

var _path = _interopRequireDefault(require("path"));

var _bundle = require("../core/bundle");

var _helpers = require("../utils/helpers");

var _build = require("./build");

var _distribute = require("./distribute");

var _repository = require("../core/repository");

var _constant = require("../constant/constant");

var _variable = require("../core/variable");

var _config = require("../utils/config");

var _i18n = _interopRequireWildcard(require("../i18n"));

var _log = _interopRequireDefault(require("../core/log"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function run(_x) {
  return _run.apply(this, arguments);
}

function _run() {
  _run = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(name) {
    var bundle, repo;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            bundle = _variable.Variable.compute([_bundle.Bundle.from(process.cwd())])[0];
            repo = new _repository.Repository(_path["default"].join(process.cwd(), _constant.DEP_FOLDER_NAME), (0, _config.getGlobalRepo)());
            _context.next = 5;
            return runCmd(bundle, repo, name);

          case 5:
            _context.next = 12;
            break;

          case 7:
            _context.prev = 7;
            _context.t0 = _context["catch"](0);
            process.exitCode = -1;

            _i18n["default"].log('run.error', {
              error: (0, _helpers.getErrorMessage)(_context.t0)
            });

            _log["default"].debug(_context.t0);

          case 12:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[0, 7]]);
  }));
  return _run.apply(this, arguments);
}

function runCmd(_x2, _x3, _x4) {
  return _runCmd.apply(this, arguments);
}

function _runCmd() {
  _runCmd = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(bundle, repo, name) {
    var useMultipleThread,
        cmd,
        _args2 = arguments;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            useMultipleThread = _args2.length > 3 && _args2[3] !== undefined ? _args2[3] : true;
            cmd = bundle.scripts(name);

            if (cmd) {
              _context2.next = 4;
              break;
            }

            throw (0, _i18n.getI18nMessage)("run.noCommand", {
              name: name
            });

          case 4:
            if (!(name === 'build')) {
              _context2.next = 9;
              break;
            }

            _context2.next = 7;
            return (0, _build.startBuild)(bundle, repo, useMultipleThread);

          case 7:
            _context2.next = 15;
            break;

          case 9:
            if (!(name === 'dist')) {
              _context2.next = 14;
              break;
            }

            _context2.next = 12;
            return (0, _distribute.bundleDist)(bundle, repo);

          case 12:
            _context2.next = 15;
            break;

          case 14:
            (0, _helpers.runCmdWithSpawnSync)(function (spawnSync) {
              return spawnSync(cmd, {
                shell: process.env.shellPath,
                env: bundle.vars.env,
                stdio: "inherit"
              });
            });

          case 15:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _runCmd.apply(this, arguments);
}