"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.update = update;
exports.updateBundle = updateBundle;

var _path = _interopRequireDefault(require("path"));

var _bundle = require("../core/bundle");

var _repository = require("../core/repository");

var _install = require("./install");

var _constant = require("../constant/constant");

var _config = require("../utils/config");

var _i18n = _interopRequireDefault(require("../i18n"));

var _log = _interopRequireDefault(require("../core/log"));

var _helpers = require("../utils/helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function update(_x) {
  return _update.apply(this, arguments);
}

function _update() {
  _update = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(descriptor) {
    var options,
        repo,
        bundle,
        needUpdate,
        _args = arguments;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            options = _args.length > 1 && _args[1] !== undefined ? _args[1] : {};
            repo = null;
            _context.prev = 2;

            if (options.global) {
              repo = new _repository.Repository('', (0, _config.getGlobalRepo)());
            } else {
              repo = new _repository.Repository(_path["default"].join(process.cwd(), _constant.DEP_FOLDER_NAME), (0, _config.getGlobalRepo)());
            }

            bundle = _bundle.Bundle.from((0, _config.getRootBundlePath)(options.global));
            _context.next = 7;
            return bundle.update(repo, options.global);

          case 7:
            needUpdate = _context.sent;
            _context.next = 10;
            return updateBundle(bundle, repo, needUpdate, descriptor, options.global);

          case 10:
            _context.next = 18;
            break;

          case 12:
            _context.prev = 12;
            _context.t0 = _context["catch"](2);
            repo.restoreSuspend(options.global);
            process.exitCode = -1;

            _i18n["default"].log("update.error", {
              error: (0, _helpers.getErrorMessage)(_context.t0)
            });

            _log["default"].debug(_context.t0);

          case 18:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[2, 12]]);
  }));
  return _update.apply(this, arguments);
}

function updateBundle(_x2, _x3) {
  return _updateBundle.apply(this, arguments);
}

function _updateBundle() {
  _updateBundle = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(bundle, repo) {
    var update,
        descriptor,
        isGlobal,
        newDescriptorArr,
        names,
        deps,
        _args2 = arguments;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            update = _args2.length > 2 && _args2[2] !== undefined ? _args2[2] : {};
            descriptor = _args2.length > 3 ? _args2[3] : undefined;
            isGlobal = _args2.length > 4 ? _args2[4] : undefined;
            newDescriptorArr = [];
            names = [];
            deps = descriptor ? (0, _install.parseInstallParam)(descriptor) : null;
            Object.keys(update).forEach(function (name) {
              if ((!deps || deps.find(function (d) {
                return d.name === name;
              })) && bundle.dependencies.find(function (d) {
                return d.name === name;
              })) {
                newDescriptorArr.push("".concat(name, "@^").concat(update[name].remote));
                names.push(name);
              }
            });

            if (!(names.length > 0)) {
              _context2.next = 15;
              break;
            }

            repo.suspend(names, isGlobal);
            _context2.next = 11;
            return (0, _install.installBundle)(bundle, repo, newDescriptorArr.join(','), {
              isGlobal: isGlobal
            });

          case 11:
            repo.deleteSuspend(isGlobal);

            _i18n["default"].log("update.success");

            _context2.next = 16;
            break;

          case 15:
            _i18n["default"].log("update.noNeedUpdate");

          case 16:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _updateBundle.apply(this, arguments);
}