"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BundleLock = void 0;

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _manifest = require("./manifest");

var _helpers = require("../utils/helpers");

var _i18n = require("../i18n");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = privateMap.get(receiver); if (!descriptor) { throw new TypeError("attempted to get private field on non-instance"); } if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = privateMap.get(receiver); if (!descriptor) { throw new TypeError("attempted to set private field on non-instance"); } if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } return value; }

var _name = new WeakMap();

var _version = new WeakMap();

var _manifests = new WeakMap();

var BundleLock = /*#__PURE__*/function () {
  function BundleLock(name, version, manifests) {
    _classCallCheck(this, BundleLock);

    _name.set(this, {
      writable: true,
      value: void 0
    });

    _version.set(this, {
      writable: true,
      value: void 0
    });

    _manifests.set(this, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldSet(this, _name, name);

    _classPrivateFieldSet(this, _version, version);

    _classPrivateFieldSet(this, _manifests, manifests);
  }

  _createClass(BundleLock, [{
    key: "findManifest",
    value: function findManifest(name) {
      return this.manifests.find(function (m) {
        return m.name === name;
      });
    }
  }, {
    key: "addOrUpdate",
    value: function addOrUpdate() {
      var _this = this;

      var manifests = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      manifests.forEach(function (m) {
        var index = _this.manifests.findIndex(function (mf) {
          return mf.name === m.name;
        });

        if (index >= 0) {
          _this.manifests.splice(index, 1, m);
        } else {
          _this.manifests.push(m);
        }
      });
    }
  }, {
    key: "remove",
    value: function remove() {
      var _this2 = this;

      var names = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      names.forEach(function (name) {
        var index = _this2.manifests.findIndex(function (mf) {
          return mf.name === name;
        });

        if (index >= 0) {
          _this2.manifests.splice(index, 1);
        }
      });
    }
  }, {
    key: "toJson",
    value: function toJson() {
      var json = {
        name: _classPrivateFieldGet(this, _name),
        version: _classPrivateFieldGet(this, _version)
      };
      json.dependencies = this.manifests.reduce(function (acc, manifest) {
        acc[manifest.name] = {
          version: manifest.version.version,
          url: manifest.url,
          checksum: manifest.checksum
        };

        if (manifest.dependencies && manifest.dependencies.length > 0) {
          acc[manifest.name].dependencies = manifest.json().dependencies;
        }

        return acc;
      }, {});
      return json;
    }
  }, {
    key: "saveToFile",
    value: function saveToFile(dir) {
      var json = this.toJson();

      var lockPath = _path["default"].join(dir, 'bundle-lock.json');

      if (_fs["default"].existsSync(lockPath)) {
        (0, _helpers.runShellCmd)(function (shell) {
          return shell.rm('-rf', lockPath);
        });
      }

      _fs["default"].writeFileSync(_path["default"].join(dir, 'bundle-lock.json'), JSON.stringify(json, null, 4));
    }
  }, {
    key: "isCompatible",
    value: function isCompatible() {
      var _this3 = this;

      var dependencies = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      if (this.manifests.length === 0) {
        return false;
      }

      var _iterator = _createForOfIteratorHelper(dependencies),
          _step;

      try {
        var _loop = function _loop() {
          var dep = _step.value;

          var found = _this3.manifests.find(function (m) {
            return m.name === dep.name;
          });

          if (!found || !dep.match(found)) {
            return {
              v: false
            };
          }
        };

        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var _ret = _loop();

          if (_typeof(_ret) === "object") return _ret.v;
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      return true;
    }
  }, {
    key: "resolve",
    value: function resolve(manifest, repo, rootManifest) {
      var _this4 = this;

      var localManifests = repo.manifests();
      var globalManifests = repo.globalManifests();
      var dependencies = manifest.getCompositeDependencies(rootManifest);
      var result = dependencies.map(function (d) {
        var found = localManifests && localManifests.find(function (rm) {
          return rm.name === d.name;
        });

        if (!found) {
          found = globalManifests && globalManifests.find(function (r) {
            return r.name === d.name;
          });
        }

        if (!found) {
          found = _this4.findManifest(d.name);
        }

        return found;
      });
      return result.filter(function (r) {
        return r;
      });
    }
  }, {
    key: "name",
    get: function get() {
      return _classPrivateFieldGet(this, _name);
    }
  }, {
    key: "version",
    get: function get() {
      return _classPrivateFieldGet(this, _version);
    }
  }, {
    key: "manifests",
    get: function get() {
      return _classPrivateFieldGet(this, _manifests) || [];
    }
  }]);

  return BundleLock;
}();

exports.BundleLock = BundleLock;

BundleLock.fromUrl = function (url) {
  function _(func, err) {
    try {
      return func();
    } catch (e) {
      if (err) {
        var error = err(e);
        if (error) throw error;
      }
    }
  }

  var content = _(function () {
    return _fs["default"].readFileSync(_path["default"].join(url, 'bundle-lock.json'));
  }, function (e) {
    return new Error((0, _i18n.getI18nMessage)("bundleLock.readJsonError", {
      url: url,
      message: e.message
    }));
  });

  var json = _(function () {
    return JSON.parse(content);
  }, function (e) {
    return new Error((0, _i18n.getI18nMessage)("bundleLock.jsonParseError", {
      message: e.message
    }));
  });

  var manifests = _(function () {
    return Object.keys(json.dependencies || {}).map(function (key) {
      return _manifest.Manifest.json(_objectSpread({
        name: key
      }, json.dependencies[key]), {
        download: {
          addr: json.dependencies[key].url,
          checksum: json.dependencies[key].checksum
        }
      });
    });
  }, function (e) {
    return new Error((0, _i18n.getI18nMessage)("bundleLock.lockError", {
      error: e
    }));
  });

  return new BundleLock(json.name, json.version, getValidLockedManifests(manifests));
};

BundleLock.fromManifests = function (manifests) {
  if (manifests && manifests.length > 0) {
    var clone = [].concat(manifests);
    var mainManifest = clone.pop();
    return new BundleLock(mainManifest.name, mainManifest.version.version, getValidLockedManifests(clone));
  }

  return null;
};

BundleLock.isExisted = function (dir) {
  return _fs["default"].existsSync(_path["default"].join(dir, 'bundle-lock.json'));
};

function getValidLockedManifests() {
  var manifests = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  return manifests.filter(function (m) {
    return m.name && m.version.version && m.url && m.checksum;
  });
}