"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getNameToBundle = getNameToBundle;
exports.Bundle = void 0;

var _fs = _interopRequireDefault(require("fs"));

var _glob = _interopRequireDefault(require("glob"));

var _path2 = _interopRequireDefault(require("path"));

var _manifest2 = require("./manifest");

var _dependency = require("./dependency");

var _variable = require("./variable");

var _dependencyGraph = require("./dependency-graph");

var _repository = require("./repository");

var _bundleLock2 = require("./bundle-lock");

var _helpers = require("../utils/helpers");

var _constant = require("../constant/constant");

var _i18n = _interopRequireWildcard(require("../i18n"));

var _config2 = require("../config.json");

var _log = _interopRequireDefault(require("./log"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = privateMap.get(receiver); if (!descriptor) { throw new TypeError("attempted to get private field on non-instance"); } if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = privateMap.get(receiver); if (!descriptor) { throw new TypeError("attempted to set private field on non-instance"); } if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } return value; }

var _path = new WeakMap();

var _manifest = new WeakMap();

var _manifests = new WeakMap();

var _vars = new WeakMap();

var _bundleLock = new WeakMap();

var Bundle = /*#__PURE__*/function () {
  function Bundle(bundlePath, manifest) {
    _classCallCheck(this, Bundle);

    _path.set(this, {
      writable: true,
      value: void 0
    });

    _manifest.set(this, {
      writable: true,
      value: void 0
    });

    _manifests.set(this, {
      writable: true,
      value: void 0
    });

    _vars.set(this, {
      writable: true,
      value: void 0
    });

    _bundleLock.set(this, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldSet(this, _path, bundlePath);

    _classPrivateFieldSet(this, _manifest, manifest);

    var _tags = {};
    var _config = {};

    var _iterator = _createForOfIteratorHelper(this.dependencies),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var dependency = _step.value;
        if (dependency.tag) _tags[dependency.tag] = (_tags[dependency.tag] ? _tags[dependency.tag] : []).concat([dependency.name]);
        if (dependency.params) _config[dependency.name] = dependency.params;
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }

    this.dependencies.tags = _tags;
    this.dependencies.config = _config;
    _classPrivateFieldGet(this, _manifest).path = bundlePath;

    _classPrivateFieldSet(this, _vars, new _variable.Variable());

    if (_fs["default"].existsSync(_path2["default"].join(_classPrivateFieldGet(this, _path), "bundle-lock.json"))) {
      _classPrivateFieldSet(this, _bundleLock, _bundleLock2.BundleLock.fromUrl(_classPrivateFieldGet(this, _path)));
    }
  }

  _createClass(Bundle, [{
    key: "scripts",
    value: function scripts(name) {
      return _classPrivateFieldGet(this, _manifest).scripts(name);
    }
  }, {
    key: "copy",
    value: function copy() {
      var dirs = _classPrivateFieldGet(this, _manifest).dirs();

      var result = {};

      if (dirs) {
        Object.keys(dirs).forEach(function (key) {
          var pattern = dirs[key];

          if (typeof pattern === "string" && pattern.startsWith("@")) {
            result[key] = pattern.substr(1);
          }
        });
      }

      return result;
    }
  }, {
    key: "link",
    value: function link() {
      var dirs = _classPrivateFieldGet(this, _manifest).dirs();

      var result = [];

      if (dirs) {
        Object.keys(dirs).forEach(function (key) {
          var pattern = dirs[key];

          if (typeof pattern === "string" && pattern.startsWith("&")) {
            result.push({
              source: pattern.substring(1),
              target: key
            });
          }
        });
      }

      return result;
    }
  }, {
    key: "files",
    value: function files(dir) {
      var _this = this;

      var patterns = _classPrivateFieldGet(this, _manifest).dirs(dir);

      if (patterns) {
        return (Array.isArray(patterns) ? patterns : [patterns]).flatMap(function (pattern) {
          return _glob["default"].sync(_path2["default"].normalize(_classPrivateFieldGet(_this, _path) + "/" + pattern));
        });
      }

      return [];
    }
  }, {
    key: "pack",
    value: function pack() {
      var _this2 = this;

      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          needSourceBin = _ref.needSourceBin;

      if (!needSourceBin) {
        // needSourceBin is used in build source bundle packing
        if (!_classPrivateFieldGet(this, _manifest).publishAs) {
          throw (0, _i18n.getI18nMessage)("bundle.missingPublishAs");
        }

        if (!_classPrivateFieldGet(this, _manifest).license) {
          throw (0, _i18n.getI18nMessage)("bundle.missingLicense");
        }
      }

      if (this.isPublishAs("source") || this.isPublishAs("distribution")) {
        if (needSourceBin) {
          return {
            bin: this.files("bin")
          };
        }

        var _packConfig = getDefaultPackConfig(_classPrivateFieldGet(this, _path));

        var dirs = _classPrivateFieldGet(this, _manifest).dirs();

        if (dirs) {
          Object.keys(dirs).forEach(function (key) {
            if (typeof dirs[key] === "string" && (dirs[key].startsWith("@") || dirs[key].startsWith("&"))) {
              return;
            }

            if (key !== "bin") {
              _packConfig[key] = (_packConfig[key] || []).concat(_this2.files(key));
            }
          });
        }

        return _packConfig;
      }

      var packConfig = getDefaultPackConfig(_classPrivateFieldGet(this, _path));

      if (this.isPublishAs("binary")) {
        return _objectSpread(_objectSpread({}, packConfig), {}, {
          bin: this.files("bin"),
          headers: this.files("headers")
        });
      }

      return null; // code-segment
    }
  }, {
    key: "build",
    value: function () {
      var _build = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(repo) {
        var needJoinLicense,
            manifests,
            bundles,
            _iterator2,
            _step2,
            manifest,
            bundle,
            totalLicensePath,
            noticeFiles,
            _args = arguments;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                needJoinLicense = _args.length > 1 && _args[1] !== undefined ? _args[1] : false;
                _context.next = 3;
                return this.install(repo, false);

              case 3:
                manifests = _context.sent;
                bundles = [];
                _iterator2 = _createForOfIteratorHelper(manifests);
                _context.prev = 6;

                _iterator2.s();

              case 8:
                if ((_step2 = _iterator2.n()).done) {
                  _context.next = 16;
                  break;
                }

                manifest = _step2.value;
                _context.next = 12;
                return Bundle.mapManifestToBundle(manifest);

              case 12:
                bundle = _context.sent;
                bundles.push(bundle);

              case 14:
                _context.next = 8;
                break;

              case 16:
                _context.next = 21;
                break;

              case 18:
                _context.prev = 18;
                _context.t0 = _context["catch"](6);

                _iterator2.e(_context.t0);

              case 21:
                _context.prev = 21;

                _iterator2.f();

                return _context.finish(21);

              case 24:
                if (needJoinLicense) {
                  totalLicensePath = _path2["default"].join(this.path, _constant.NOTICE_NAME);
                  noticeFiles = [];
                  bundles.forEach(function (bundle) {
                    if (bundle.path) {
                      var noticeFile = _path2["default"].join(bundle.path, bundle.manifest.noticeFile);

                      if (_fs["default"].existsSync(noticeFile)) {
                        noticeFiles.push(noticeFile);
                      }
                    }
                  });
                  Bundle.resolveNotice(noticeFiles, totalLicensePath);
                }

                return _context.abrupt("return", _variable.Variable.compute(bundles));

              case 26:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[6, 18, 21, 24]]);
      }));

      function build(_x) {
        return _build.apply(this, arguments);
      }

      return build;
    }()
  }, {
    key: "isPublishAs",
    value: function isPublishAs(publishAs) {
      return this.manifest.publishAs === publishAs;
    }
  }, {
    key: "install",
    value: function () {
      var _install = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(repo, isGlobal) {
        var manifests, manifestGraph, _manifestGraph;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                manifests = null;

                if (!(_classPrivateFieldGet(this, _bundleLock) && _classPrivateFieldGet(this, _bundleLock).isCompatible(this.dependencies))) {
                  _context2.next = 8;
                  break;
                }

                _context2.next = 4;
                return _dependencyGraph.DependencyGraph.buildFromLock(this, _classPrivateFieldGet(this, _bundleLock), repo);

              case 4:
                manifestGraph = _context2.sent;
                manifests = manifestGraph.traverse();
                _context2.next = 13;
                break;

              case 8:
                _context2.next = 10;
                return _dependencyGraph.DependencyGraph.build(this, repo);

              case 10:
                _manifestGraph = _context2.sent;
                manifests = _manifestGraph.traverse();

                if (!isGlobal) {
                  this.updateLockJsonForInstall(manifests);
                }

              case 13:
                printLicenseRiskWarn(manifests);

                _classPrivateFieldSet(this, _manifests, manifests);

                return _context2.abrupt("return", manifests);

              case 16:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function install(_x2, _x3) {
        return _install.apply(this, arguments);
      }

      return install;
    }()
  }, {
    key: "update",
    value: function () {
      var _update = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(repo) {
        var _this3 = this;

        var localManifests, globalManifests, manifestGraph, remoteManifests, needUpdate;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                localManifests = repo.manifests();
                globalManifests = repo.globalManifests();
                _context3.next = 4;
                return _dependencyGraph.DependencyGraph.build(this, repo.remoteRepo);

              case 4:
                manifestGraph = _context3.sent;
                remoteManifests = manifestGraph.traverse();
                needUpdate = {};
                remoteManifests.forEach(function (remote) {
                  if (remote.name === _this3.manifest.name) {
                    return;
                  }

                  var local = localManifests.find(function (localManifest) {
                    return localManifest.name === remote.name;
                  });

                  if (local) {
                    if (local.version.version !== remote.version.version) {
                      needUpdate[remote.name] = {
                        local: local.version.version,
                        global: "",
                        remote: remote.version.version
                      };
                    }
                  } else {
                    var global = globalManifests.find(function (m) {
                      return m.name === remote.name;
                    });

                    if (global) {
                      if (global.version.version !== remote.version.version) {
                        needUpdate[remote.name] = {
                          local: "miss",
                          global: global.version.version,
                          remote: remote.version.version
                        };
                      }
                    } else {
                      needUpdate[remote.name] = {
                        local: "miss",
                        global: "miss",
                        remote: remote.version.version
                      };
                    }
                  }
                });
                return _context3.abrupt("return", needUpdate);

              case 9:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function update(_x4) {
        return _update.apply(this, arguments);
      }

      return update;
    }()
  }, {
    key: "addDependencies",
    value: function addDependencies(dependencies, type) {
      _classPrivateFieldGet(this, _manifest).addDependencies(dependencies, type);
    }
  }, {
    key: "removeDependencies",
    value: function removeDependencies(names, type) {
      var _this4 = this;

      var baseName = names.find(function (name) {
        var bName = _this4.manifest.base && _this4.manifest.base.name;
        return bName === name;
      });

      if (baseName) {
        _classPrivateFieldGet(this, _manifest).removeBase({
          name: baseName
        });
      }

      _classPrivateFieldGet(this, _manifest).removeDependencies(names, type);
    }
  }, {
    key: "updateDependencies",
    value: function updateDependencies(dependencies, type) {
      var _this5 = this;

      var newDependencies = [];
      var base = null;

      var _iterator3 = _createForOfIteratorHelper(dependencies),
          _step3;

      try {
        var _loop = function _loop() {
          var dep = _step3.value;

          var manifest = _classPrivateFieldGet(_this5, _manifests).find(function (m) {
            return m.name === dep.name;
          });

          if (manifest) {
            var versionRanges = dep.versionRanges && dep.versionRanges !== "*" ? dep.versionRanges : "^".concat(manifest.version.version);

            if (manifest.publishAs === "distribution") {
              base = {
                name: dep.name,
                version: versionRanges
              };
            } else {
              newDependencies.push(new _dependency.Dependency(dep.name, versionRanges));
            }
          }
        };

        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          _loop();
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }

      if (base) {
        _classPrivateFieldGet(this, _manifest).updateBase(base);
      }

      if (newDependencies.length > 0) {
        _classPrivateFieldGet(this, _manifest).updateDependencies(newDependencies, type);
      }
    }
  }, {
    key: "updateBundleJson",
    value: function updateBundleJson() {
      var json = this.manifest.json();

      _fs["default"].writeFileSync(_path2["default"].join(_classPrivateFieldGet(this, _path), "bundle.json"), JSON.stringify(json, null, 4));
    }
  }, {
    key: "updateLockJsonForInstall",
    value: function updateLockJsonForInstall(manifests) {
      if (_classPrivateFieldGet(this, _bundleLock)) {
        var needUpdateManifests = manifests.filter(function (m) {
          return !!m.url;
        });

        _classPrivateFieldGet(this, _bundleLock).addOrUpdate(needUpdateManifests);
      } else {
        _classPrivateFieldSet(this, _bundleLock, _bundleLock2.BundleLock.fromManifests(manifests));
      }

      if (_classPrivateFieldGet(this, _bundleLock)) {
        _classPrivateFieldGet(this, _bundleLock).saveToFile(_classPrivateFieldGet(this, _path));
      }
    }
  }, {
    key: "updateLockJsonForUnInstall",
    value: function updateLockJsonForUnInstall(manifestNameList) {
      if (_classPrivateFieldGet(this, _bundleLock)) {
        _classPrivateFieldGet(this, _bundleLock).remove(manifestNameList);

        _classPrivateFieldGet(this, _bundleLock).saveToFile(_classPrivateFieldGet(this, _path));
      }
    }
  }, {
    key: "vars",
    get: function get() {
      return _classPrivateFieldGet(this, _vars);
    }
  }, {
    key: "manifest",
    get: function get() {
      return _classPrivateFieldGet(this, _manifest);
    }
  }, {
    key: "name",
    get: function get() {
      return _classPrivateFieldGet(this, _manifest).name;
    }
  }, {
    key: "id",
    get: function get() {
      return this.manifest.id;
    }
  }, {
    key: "dependencies",
    get: function get() {
      return _classPrivateFieldGet(this, _manifest).dependencies;
    }
  }, {
    key: "path",
    get: function get() {
      return _classPrivateFieldGet(this, _path);
    }
  }, {
    key: "binary",
    get: function get() {
      return _classPrivateFieldGet(this, _path);
    }
  }, {
    key: "lock",
    get: function get() {
      return _classPrivateFieldGet(this, _bundleLock);
    }
  }], [{
    key: "resolveNotice",
    value: function resolveNotice(noticeFiles, filePath) {
      _i18n["default"].log("notice.generating");

      var noticeObject = {};
      noticeFiles.forEach(function (nf) {
        var subNoticeArray = _fs["default"].readFileSync(nf).toString().split("Software:");

        subNoticeArray.forEach(function (notice, index) {
          if (index !== 0 && notice && notice.includes("\n")) {
            var key = "Software: ".concat(notice.substring(0, notice.indexOf("\n")).trim());
            var value = notice.substring(notice.indexOf("\n")).trim();
            noticeObject[key] = value;
          }
        });
      });

      var prefix = _fs["default"].readFileSync(_path2["default"].join(__dirname, '..', 'asset', 'notice-prefix'));

      var noticeString = Object.keys(noticeObject).reduce(function (notice, key) {
        return "".concat(notice, "\n\n").concat(key, "\n\n").concat(noticeObject[key]);
      }, prefix || "");
      var trimed = noticeString && noticeString.trim && noticeString.trim() || '';

      _fs["default"].writeFileSync(filePath, trimed);

      _i18n["default"].log("notice.success");
    }
  }]);

  return Bundle;
}();

exports.Bundle = Bundle;

Bundle.from = function (dir) {
  var manifest = _manifest2.Manifest.fromPath(dir);

  return new Bundle(dir, manifest);
};

Bundle.mapManifestToBundle = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(manifest) {
    var bundlePath;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            bundlePath = manifest.path;

            if (!manifest.url) {
              _context4.next = 5;
              break;
            }

            _context4.next = 4;
            return (0, _repository.bundleDownload)(manifest, false);

          case 4:
            bundlePath = _context4.sent;

          case 5:
            return _context4.abrupt("return", Bundle.from(bundlePath));

          case 6:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));

  return function (_x5) {
    return _ref2.apply(this, arguments);
  };
}();

function getNameToBundle(bundles) {
  var result = new Map();

  var _iterator4 = _createForOfIteratorHelper(bundles),
      _step4;

  try {
    for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
      var bundle = _step4.value;
      result.set(bundle.name, bundle);
    }
  } catch (err) {
    _iterator4.e(err);
  } finally {
    _iterator4.f();
  }

  return result;
}

function getDefaultPackConfig(bundlePath) {
  var autoPackFiles = [{
    name: "bundle.json",
    required: true
  }, {
    name: "README.md",
    required: true
  }, {
    name: "LICENSE",
    required: true
  }, {
    name: "AUTHOR",
    required: false
  }, {
    name: "README_EN.md",
    required: false
  }, {
    name: "README_CN.md",
    required: false
  }];
  var packConfig = {
    ".": []
  };
  autoPackFiles.forEach(function (_ref3) {
    var name = _ref3.name,
        required = _ref3.required;

    var filePath = _path2["default"].join(bundlePath, name);

    if (_fs["default"].existsSync(filePath)) {
      packConfig["."].push(filePath);

      var stats = _fs["default"].statSync(filePath);

      if (stats.size === 0) {
        throw (0, _i18n.getI18nMessage)("bundle.fileShouldNotEmpty", {
          name: name
        });
      }
    } else if (required) {
      throw (0, _i18n.getI18nMessage)("bundle.fileRequired", {
        name: name
      });
    }
  });
  return packConfig;
}

function printLicenseRiskWarn(manifests) {
  if (!manifests) {
    return;
  }

  var allow = _config2.allowedLicenses.map(function (a) {
    return a.toUpperCase();
  });

  var riskManifests = manifests.filter(function (m, index) {
    var licenseName = (m.license || '').toUpperCase();
    return licenseName && !allow.includes(licenseName) && index !== manifests.length - 1;
  });
  riskManifests.forEach(function (rm) {
    _log["default"].warnConsole((0, _i18n.getI18nMessage)("license.warn", {
      bundleName: rm.name,
      license: rm.license || 'empty'
    }));
  });
}