"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DependencyGraph = void 0;

var _semver = _interopRequireDefault(require("semver"));

var _i18n = require("../i18n");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = privateMap.get(receiver); if (!descriptor) { throw new TypeError("attempted to get private field on non-instance"); } if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = privateMap.get(receiver); if (!descriptor) { throw new TypeError("attempted to set private field on non-instance"); } if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } return value; }

var _manifests = new WeakMap();

var _dependencies = new WeakMap();

var DependencyGraph = /*#__PURE__*/function () {
  function DependencyGraph(manifests, dependencies) {
    _classCallCheck(this, DependencyGraph);

    _manifests.set(this, {
      writable: true,
      value: void 0
    });

    _dependencies.set(this, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldSet(this, _manifests, manifests);

    _classPrivateFieldSet(this, _dependencies, dependencies);
  }

  _createClass(DependencyGraph, [{
    key: "dependencies",
    value: function dependencies(manifest) {
      var _this = this;

      return _classPrivateFieldGet(this, _dependencies)[manifest.name].map(function (_) {
        return _classPrivateFieldGet(_this, _manifests)[_];
      });
    }
  }, {
    key: "traverse",
    value: function traverse() {
      var _this2 = this;

      var dependencies = JSON.parse(JSON.stringify(_classPrivateFieldGet(this, _dependencies)));
      var result = [];

      while (Object.keys(dependencies).length !== 0) {
        var _loop = function _loop() {
          var dependency = _Object$keys[_i];

          if (dependencies[dependency].length === 0) {
            result.push(_classPrivateFieldGet(_this2, _manifests)[dependency]);
            delete dependencies[dependency];

            for (var _i2 = 0, _Object$keys2 = Object.keys(dependencies); _i2 < _Object$keys2.length; _i2++) {
              var d = _Object$keys2[_i2];
              dependencies[d] = dependencies[d].filter(function (_) {
                return _ !== dependency;
              });
            }
          }
        };

        for (var _i = 0, _Object$keys = Object.keys(dependencies); _i < _Object$keys.length; _i++) {
          _loop();
        }
      }

      return result;
    }
  }, {
    key: "manifests",
    get: function get() {
      return _classPrivateFieldGet(this, _manifests);
    }
  }]);

  return DependencyGraph;
}();

exports.DependencyGraph = DependencyGraph;

function build(_x, _x2) {
  return _build.apply(this, arguments);
}

function _build() {
  _build = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(bundle, resolve) {
    var manifests, dependencies, versionRanges, excludes, addDependencies, _addDependencies;

    return regeneratorRuntime.wrap(function _callee6$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            _addDependencies = function _addDependencies3() {
              _addDependencies = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(manifestArray) {
                var _iterator, _step, _loop2;

                return regeneratorRuntime.wrap(function _callee5$(_context6) {
                  while (1) {
                    switch (_context6.prev = _context6.next) {
                      case 0:
                        _iterator = _createForOfIteratorHelper(manifestArray);
                        _context6.prev = 1;
                        _loop2 = /*#__PURE__*/regeneratorRuntime.mark(function _loop2() {
                          var manifest, bundleName, filteredDeps, compositeDeps, resolvedDependencies, _iterator2, _step2, dependenceManifest, dependenceManifestName, currentRange;

                          return regeneratorRuntime.wrap(function _loop2$(_context5) {
                            while (1) {
                              switch (_context5.prev = _context5.next) {
                                case 0:
                                  manifest = _step.value;
                                  bundleName = manifest.name;
                                  filteredDeps = {};
                                  compositeDeps = manifest.getCompositeDependencies(bundle.manifest);
                                  compositeDeps.forEach(function (dependency) {
                                    if (excludes.indexOf(dependency.name) >= 0) {
                                      if (!dependency.isOptional) {
                                        throw (0, _i18n.getI18nMessage)("dependency.excludeError");
                                      }
                                    } else {
                                      filteredDeps[dependency.name] = true;
                                      versionRanges[dependency.name] = "".concat(dependency.versionRanges).concat(versionRanges[dependency.name] ? " ".concat(versionRanges[dependency.name]) : '');
                                    }
                                  });
                                  _context5.next = 7;
                                  return resolve(manifest, bundle.manifest);

                                case 7:
                                  resolvedDependencies = _context5.sent;
                                  resolvedDependencies = resolvedDependencies.filter(function (_) {
                                    return filteredDeps[_.name];
                                  });
                                  manifests[bundleName] = manifest;
                                  _iterator2 = _createForOfIteratorHelper(resolvedDependencies);
                                  _context5.prev = 11;

                                  _iterator2.s();

                                case 13:
                                  if ((_step2 = _iterator2.n()).done) {
                                    _context5.next = 24;
                                    break;
                                  }

                                  dependenceManifest = _step2.value;
                                  dependenceManifestName = dependenceManifest.name;
                                  currentRange = versionRanges[dependenceManifestName];

                                  if (!_semver["default"].satisfies(dependenceManifest.version, currentRange, {
                                    includePrerelease: true
                                  })) {
                                    _context5.next = 21;
                                    break;
                                  }

                                  manifests[dependenceManifestName] = dependenceManifest;
                                  _context5.next = 22;
                                  break;

                                case 21:
                                  throw (0, _i18n.getI18nMessage)("dependency.incompatibleError", {
                                    name: dependenceManifestName,
                                    version: dependenceManifest.version.version
                                  });

                                case 22:
                                  _context5.next = 13;
                                  break;

                                case 24:
                                  _context5.next = 29;
                                  break;

                                case 26:
                                  _context5.prev = 26;
                                  _context5.t0 = _context5["catch"](11);

                                  _iterator2.e(_context5.t0);

                                case 29:
                                  _context5.prev = 29;

                                  _iterator2.f();

                                  return _context5.finish(29);

                                case 32:
                                  dependencies[bundleName] = resolvedDependencies.map(function (_) {
                                    return _.name;
                                  });

                                  if (manifest.excludes) {
                                    excludes = excludes.concat(manifest.excludes);
                                  }

                                  _context5.next = 36;
                                  return addDependencies(resolvedDependencies);

                                case 36:
                                case "end":
                                  return _context5.stop();
                              }
                            }
                          }, _loop2, null, [[11, 26, 29, 32]]);
                        });

                        _iterator.s();

                      case 4:
                        if ((_step = _iterator.n()).done) {
                          _context6.next = 8;
                          break;
                        }

                        return _context6.delegateYield(_loop2(), "t0", 6);

                      case 6:
                        _context6.next = 4;
                        break;

                      case 8:
                        _context6.next = 13;
                        break;

                      case 10:
                        _context6.prev = 10;
                        _context6.t1 = _context6["catch"](1);

                        _iterator.e(_context6.t1);

                      case 13:
                        _context6.prev = 13;

                        _iterator.f();

                        return _context6.finish(13);

                      case 16:
                      case "end":
                        return _context6.stop();
                    }
                  }
                }, _callee5, null, [[1, 10, 13, 16]]);
              }));
              return _addDependencies.apply(this, arguments);
            };

            addDependencies = function _addDependencies2(_x12) {
              return _addDependencies.apply(this, arguments);
            };

            manifests = {};
            dependencies = {};
            versionRanges = {};
            excludes = [];
            _context7.next = 8;
            return addDependencies([bundle.manifest]);

          case 8:
            return _context7.abrupt("return", new DependencyGraph(manifests, dependencies, bundle));

          case 9:
          case "end":
            return _context7.stop();
        }
      }
    }, _callee6);
  }));
  return _build.apply(this, arguments);
}

;

DependencyGraph.build = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(bundle, repository) {
    var result;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return build(bundle, /*#__PURE__*/function () {
              var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(manifest, rootManifest) {
                var depManifestList;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.next = 2;
                        return repository.resolve(manifest, rootManifest);

                      case 2:
                        depManifestList = _context.sent;
                        return _context.abrupt("return", depManifestList);

                      case 4:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function (_x5, _x6) {
                return _ref2.apply(this, arguments);
              };
            }());

          case 2:
            result = _context2.sent;
            return _context2.abrupt("return", result);

          case 4:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function (_x3, _x4) {
    return _ref.apply(this, arguments);
  };
}();

DependencyGraph.buildFromLock = /*#__PURE__*/function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(bundle, bundleLock, repository) {
    var result;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return build(bundle, /*#__PURE__*/function () {
              var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(manifest, rootManifest) {
                var depManifestList;
                return regeneratorRuntime.wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        _context3.next = 2;
                        return bundleLock.resolve(manifest, repository, rootManifest);

                      case 2:
                        depManifestList = _context3.sent;
                        return _context3.abrupt("return", depManifestList);

                      case 4:
                      case "end":
                        return _context3.stop();
                    }
                  }
                }, _callee3);
              }));

              return function (_x10, _x11) {
                return _ref4.apply(this, arguments);
              };
            }());

          case 2:
            result = _context4.sent;
            return _context4.abrupt("return", result);

          case 4:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));

  return function (_x7, _x8, _x9) {
    return _ref3.apply(this, arguments);
  };
}();